#include <kvs/StructuredVolumeObject>
#include <kvs/StructuredVolumeImporter>
#include <kvs/RayCastingRenderer>
#include <kvs/Application>
#include <kvs/Screen>

int main( int argc, char** argv )
{
  
  if( !(argc == 2 ) ) {
    std::cerr << "USAGE (1): ./RayCasting volume_data" ;
    std::cerr << std::endl;
    exit(1) ;
  }  

    kvs::StructuredVolumeObject* object 
      = new kvs::StructuredVolumeImporter( std::string( argv[1] ) );

    if ( !object )
    {
        kvsMessageError( "Cannot create a structured volume object." );
        return( false );
    }

    kvs::RayCastingRenderer* renderer = new kvs::RayCastingRenderer();
    if ( !renderer )
    {
        kvsMessageError( "Cannot create a ray casting renderer." );
        delete object;
        return( false );
    }

    kvs::Application app( argc, argv );
    kvs::Screen screen( &app );
    // Screen NXɃIuWFNg Renderer o^
    screen.registerObject( object, renderer );
    screen.setGeometry( 0, 0, 512, 512 );
    screen.setTitle( "RayCastingRenderer" );
    screen.show();

    return( app.run() );
}
